package envoy.client.ui.settings;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionListener;

import envoy.client.event.EventBus;
import envoy.client.event.OnCloseChangeEvent;
import envoy.client.event.ThemeChangeEvent;
import envoy.client.ui.PrimaryToggleSwitch;

/**
 * Displays GUI components that allow general settings regarding the client.<br>
 * <br>
 * 
 * Project: <strong>envoy-client</strong><br>
 * File: <strong>General.java</strong><br>
 * Created: <strong>21 Dec 2019</strong><br>
 * 
 * @author Maximilian K&auml;fer
 * @since Envoy v0.2-alpha
 */
public class General extends SettingsPanel {
	
	private static final long serialVersionUID = -7470848775130754239L;
	
	private String variable = "exit";
	PrimaryToggleSwitch toggleSwitch = new PrimaryToggleSwitch(false,"envoy.client.event.OnCloseChangeEvent");
	
	/**
	 * This is the constructor for the General class. Here the user can set general settings for the client.
	 * @since Envoy 0.3-alpha
	 */
	public General() {
		
		GridBagLayout gbl_general = new GridBagLayout();
		gbl_general.columnWidths = new int[] { 1, 1 };
		gbl_general.rowHeights = new int[] { 1, 1 };
		gbl_general.columnWeights = new double[] { 1.0, 1.0 };
		gbl_general.rowWeights = new double[] { 1.0, 1.0 };

		setLayout(gbl_general);
		
		GridBagConstraints gbc_toggleSwitch = new GridBagConstraints();
		gbc_toggleSwitch.gridx = 0;
		gbc_toggleSwitch.gridy = 0;

		add(toggleSwitch, gbc_toggleSwitch);
		
		EventBus.getInstance().register(OnCloseChangeEvent.class, (evt) -> changeOnClose(((OnCloseChangeEvent) evt).get()));
	}
	
	/**
	 * This method changes the on close mode of the client.
	 * 
	 * @param state This is the integer that defines weather the toggleSwitch is on or off.
	 * @since Envoy v0.3-alpha
	 */
	public void changeOnClose(int state) {
		System.out.println(state);
	}
	
	@Override
	public ActionListener getOkButtonAction() {
		// TODO Auto-generated method stub
		return null;
	}

}
